#
# DNS Packet parser
#

###########################################################################


# ̤줿ǡŸƼФ
def expand_rr(packet, pos)
  buf = ""
  real_len = 0
  flag = FALSE

  while TRUE
    break if packet[pos] == nil || packet.size == pos - 1

    if (packet[pos] & 0x80) != 0
      pos = (packet[pos,2].unpack("n")[0]) & 0x3fff
      if flag == FALSE
        real_len += 2
      end
      flag = TRUE

    elsif packet[pos] != 0
      len = packet[pos]+1
      buf += packet[pos,len]
      pos += len
      if flag == FALSE
        real_len += len
      end

    else
      buf += packet[pos,1]
      if flag == FALSE
        real_len += 1
      end

      break

    end
  end

  ret = {
    "data" => buf,
    "real_len" => real_len
  }

#p ret
  return ret
end

# ġ RR μˤǡŸˡۤʤ롣
# 䤳
def expand_data(packet, pos, type)
  data_len = packet[pos,  2].unpack("n")[0]
  data_pos = pos + 2

  case type
  when DnsType::NS, DnsType::TXT, DnsType::PTR, DnsType::CNAME
    tmp      = expand_rr(packet, data_pos)
    data     = tmp["data"]
  when DnsType::SOA
    tmp      = expand_rr(packet, data_pos)
    host     = tmp["data"]
    host_len = tmp["real_len"]

    tmp      = expand_rr(packet, data_pos + host_len)
    mail     = tmp["data"]
    mail_len = tmp["real_len"]

    data     = host + mail + packet[data_pos + host_len + mail_len, 4 * 5]
  when DnsType::MX
    tmp = expand_rr(packet, data_pos + 2)
    data = packet[data_pos, 2] + tmp["data"]
  else
    data     = packet[data_pos, data_len]
  end

  return {
    "data"     => data,
    "real_len" => data_len
  }
end


def parse_answer(packet, pos)
  ret = []

  while TRUE
    if pos >= packet.length
      break
    end

    rr  = expand_rr(packet, pos)
    len = rr["real_len"]

    a        = rr["data"]

    a_type   = packet[pos+len,    2]
    a_class  = packet[pos+len+2,  2]
    ttl      = packet[pos+len+4,  4]

    data = expand_data(packet, pos+len+8, a_type)

    ret << {
      "a"       => a,
      "a_type"  => a_type,
      "a_class" => a_class,
      "ttl"     => ttl,
      "data"    => data["data"],
    }

    pos += len + 2 + 2 + 4 + 2 + data["real_len"]
  end

#p ret
  return ret
end

############################################################################

# DNS ѥå Ϥ֤
def parse_packet(packet)
  return nil if packet.length < 12

  (id, flags, num_q, ans_rr, ort_rr, add_rr, str) =  packet.unpack("a2 a2 a2 a2 a2 a2 a*")

  return nil if num_q.unpack("n")[0] != 1

  rr = expand_rr(packet, 12)
  rr_len = rr["real_len"]

  (q, q_type, q_class, answer) = str.unpack("a#{rr_len.to_s} a2 a2 a*")

  ret = {
    "packet" => packet,
    "id"     => id,
    "flags"  => flags,
    "num_q"  => num_q,
    "ans_rr" => ans_rr,
    "ort_rr" => ort_rr,
    "add_rr" => add_rr,
    "query"  => [
      {
        "q"       => q,
        "q_type"  => q_type,
        "q_class" => q_class
      }
    ],
  }

  # 褦ʤ餽Ÿ
  if ans_rr != "\0\0" || ort_rr != "\0\0" || add_rr != "\0\0"
    ret["answer"] = parse_answer(packet, 12+rr_len+2+2)
  end

  return ret
end

############################################################################

#  RR 򥿥̤ʸ󲽤
def dnsdata_to_str(data, type)
  case type
  when DnsType::A
    return ipstr_to_str(data)
  when DnsType::NS, DnsType::PTR, DnsType::CNAME
    return dnsstr_to_str(data)
  when DnsType::SOA
    (host, mail) = data.split("\0")[0,2].collect {
      |i|
      dnsstr_to_str(i + "\0")
    }
    pos = data.size-4*5
    return ([host, mail] +
	    str_split(data[pos...data.size], 4).collect{|i| i.unpack("N")[0].to_s}
	    ).join(" ")
  when DnsType::MX
    return [data[0,2].unpack("n")[0].to_s, dnsstr_to_str(data[2...data.size])].join(" ")
  when DnsType::AAAA
    return str_split(data.unpack("H*")[0], 4).join(":")
  else
    return data.dump
  end
end

# end
